cordova.define("sozone-cordova-plugin-okapp.racloudUtils", function(require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/
var utils = require('cordova/utils'), cordova = require('cordova');

//  let baseURLFromStorage="";
//  let okappURLFromStorage="";
//  okapp.getStorage(
// 	"okapp",
// 	"racloud_url",
// 	function (value) {
// 		baseURLFromStorage=value;
// 	},
// 	function (error) {
// 	  console.log("SELECT value error: " + error.message);
// 	  return null;
// 	}
//   );
//   okapp.getStorage(
// 	"okapp",
// 	"okapp_url",
// 	function (value) {
// 		okappURLFromStorage=value;
// 	},
// 	function (error) {
// 	  console.log("SELECT value error: " + error.message);
// 	  return null;
// 	}
//   );

let racloud_api = 'http://ra-cloud.okap.com/service';
let racloud_api_test = 'http://test-ra-cloud.okap.com/service';

let okapp_api = 'okapp://www.okap.com/oauth';
let okapp_api_test = 'okapp://test-www.okap.com/oauth';
module.exports = {
	racloud_api_test:racloud_api_test,
	okapp_api_test:okapp_api_test,
	racloud_api:racloud_api,
	okapp_api:okapp_api,
	/**
	* check 云盾是否安装
	*/
	check: function (successCallback, errorCallback) {

		if (device.platform == 'iOS') {
			appAvailability.check(

				'racloud://', // Package Name
				function (info) {           // Success callback        
					// Info parameter is available only for android
					console.log(info);
					successCallback(info);
				},
				function (error) {           // Error callback
					console.log('云盾 is not available');
					errorCallback(error);
				}
			);
		} else {
			appAvailability.check(
				'com.zhudun', // Package Name
				function (info) {           // Success callback        
					// Info parameter is available only for android
					console.log(info);
					successCallback(info);
				},
				function (error) {           // Error callback
					console.log('云盾 is not available');
					errorCallback(error);
				}
			);
		}


	},
	/**
	* 验证第三方有效性接口
	*/
	validate: function (clientid, successCallback, errorCallback) {
		var self = this;
		okapp.getRacloudUrl(function (isTestSource) {
			console.log("isTestSource:"+isTestSource);
			var optionsParam = {
				method: 'get',
				data: {}
			};
			var url = (isTestSource == "test"?racloud_api_test:racloud_api) + "/o2mas/validate?client_id=" + clientid + "&response_type=code&redirect_uri=" + (isTestSource == "test"?okapp_api_test:okapp_api) + "&scope=all&state=";
			okapp.request(url, optionsParam, function (data, response) {
				console.log("racloudUtils.validate结果:" + JSON.stringify(response));
				successCallback(data, response);
			}, function (error, response) {
				console.error("racloudUtils.validate结果:" + JSON.stringify(response));
				errorCallback(error, response);
			});
		})
	},

	/**
	* 打开云盾
	* @param orderid 订单号
	* @param comp 组件默认okapp即为好应用首页登录 webview:即为小程序内登录
	**/
	startRaCloud: function (orderid, comp, successCallback, errorCallback) {
		console.log("open url:" + "racloud://ra-cloud.okap.com/oauthOkapp?order_id=" + orderid + "&pkgname=com.sozone.app.okapp&urlscheme=okapp");
		var sApp = null;
		if (device.platform == 'iOS') {
			sApp = startApp.set("racloud://ra-cloud.okap.com/oauthOkapp?order_id=" + orderid + "&pkgname=com.sozone.app.okapp&urlscheme=okapp&comp=" + comp);

		} else {
			sApp = startApp.set({
				"action": "ACTION_VIEW",
				"uri": "racloud://ra-cloud.okap.com/oauthOkapp?order_id=" + orderid + "&pkgname=com.sozone.app.okapp&urlscheme=okapp&comp=" + comp,
				"package": "com.zhudun"
			});
		}
		sApp.start(function (complete) { // if receiver is registered
			console.log(complete);
			successCallback(complete);
		}, function (error) {
			console.error(error);
			errorCallback(error);
		});
	},

	/**
	* 返回用户授权并获取Auth Code
	*/
	getAuthCode: function (orderid, successCallback, errorCallback) {
		okapp.getRacloudUrl(function (isTestSource) {

			var optionsParam = {
				method: 'get',
				data: {}
			};
			var url = (isTestSource == "test"?racloud_api_test:racloud_api) + "/o2mas/code?order_id=" + orderid;
			okapp.request(url, optionsParam, function (data, response) {
				console.log("racloudUtils.getAuthCode结果:" + JSON.stringify(response));
				successCallback(data, response);
			}, function (error, response) {
				console.error("racloudUtils.getAuthCode结果:" + JSON.stringify(response));
				errorCallback(error, response);
			});
		})
	},

	/**
	* 第三方APP使用Auth Code或者refresh_token换取Access Token
	*/
	getAccessToken: function (clientid, authcode, successCallback, errorCallback) {
		okapp.getRacloudUrl(function (isTestSource) {

			var optionsParam = {
				method: 'post',
				data: {
					client_id: clientid,
					grant_type: 'authorization_code',
					client_secret: '63a0d71142fcb59d79aacb041ebedab5263790ebe6a0ceb480a7b20827e3a2d8b772ff7fd521bb51b41ca45bafd60b1d',
					code: authcode,
					redirect_uri: 'okapp://www.okap.com/oauth'
				}
			};
			var url = (isTestSource == "test"?racloud_api_test:racloud_api) + "/oauth2/token";
			console.log("调用getAccessToken:" + url + "  参数：" + JSON.stringify(optionsParam));
			okapp.request(url, optionsParam, function (data, response) {
				console.log("racloudUtils.getAccessToken结果:" + JSON.stringify(response));
				successCallback(data, response);
			}, function (error, response) {
				console.error("racloudUtils.getAccessToken结果:" + JSON.stringify(response));
				errorCallback(error, response);
			});
		})
	},
	getCertInfo: function (access_token, successCallback, errorCallback) {
		okapp.getRacloudUrl(function (isTestSource) {

			var optionsParam = {
				method: 'get', headers: { Authorization: 'Bearer ' + access_token }
			};
			var url = (isTestSource == "test"?racloud_api_test:racloud_api) + "/o2api/cert/current";
			console.log("调用/o2api/cert/current:" + url + "  参数：" + JSON.stringify(optionsParam));
			okapp.request(url, optionsParam, function (data, response) {
				console.log("racloudUtils.getCaInfo结果:" + JSON.stringify(response));
				successCallback(data, response);
			}, function (error, response) {
				console.error("racloudUtils.getCaInfo结果:" + JSON.stringify(response));
				errorCallback(error, response);
			});
		})
	}
	,
	getUserInfo: function (access_token, successCallback, errorCallback) {
		okapp.getRacloudUrl(function (isTestSource) {

			var optionsParam = {
				method: 'get', headers: { Authorization: 'Bearer ' + access_token }
			};
			var url = (isTestSource == "test"?racloud_api_test:racloud_api) + "/o2api/cert/userinfo";
			console.log("调用/o2api/cert/userinfo:" + url + "  参数：" + JSON.stringify(optionsParam));
			okapp.request(url, optionsParam, function (data, response) {
				console.log("racloudUtils.getUserInfo结果:" + JSON.stringify(response));
				successCallback(data, response);
			}, function (error, response) {
				console.error("racloudUtils.getUserInfo结果:" + JSON.stringify(response));
				errorCallback(error, response);
			});
		})
	}
	//http://ra-cloud.okap.com/service/o2api/cert/current?access_token=bbcfaa07e5db8faa3270cf0e059efcff
};

});
